namespace CMSMicroservice.Application.CommissionCQ.Commands.CalculateWeeklyBalances;

public class CalculateWeeklyBalancesCommandValidator : AbstractValidator<CalculateWeeklyBalancesCommand>
{
    public CalculateWeeklyBalancesCommandValidator()
    {
        RuleFor(x => x.WeekDefinitionId)
            .NotNull()
            .GreaterThan(0)
            .WithMessage("شماره هفته نمی‌تواند خالی باشد")
;
    }

    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(
            ValidationContext<CalculateWeeklyBalancesCommand>.CreateWithOptions(
                (CalculateWeeklyBalancesCommand)model,
                x => x.IncludeProperties(propertyName)));

        if (result.IsValid)
            return Array.Empty<string>();

        return result.Errors.Select(e => e.ErrorMessage);
    };
}
